class exports.Enum

  constructor: (values = {}) ->
    _keys = []
    for key, value of values
      value.__id__ = _keys.length
      _keys.push key
      @[key] = value
    @keys = -> _keys.slice 0

  keyOf: (obj) -> @keys()[obj.__id__]

  validate: (obj) -> obj? && obj.__id__ >= 0 && obj.__id__ < @keys().length

  eq: (x, y) -> x? && y? && x.__id__ == y.__id__

  keys: -> throw new TypeError "Called keys() on an incompatible object"
