class exports.Trait

  constructor: (@name = "", @methods = {}) ->

  fromParent: (parent) ->
    for method, value of parent.methods
      @methods[method] = value if !@methods[method]?
    @

  validate: (obj) ->
    for method, _ of @methods
      return false if typeof obj[method] != "function"
    true

  implementFor: (obj, override = {}) ->
    for method, val of @methods
      if typeof obj[method] != "function"
        if typeof override[method] == "function"
          obj[method] = override[method]
        else if typeof val == "function"
          obj[method] = val
        else throw new TypeError "The trait #{@name} was incorrectly implemented. Missing method #{method}"
    obj
